macroScript ASCII_export category:"Export Tools" tooltip:"Miguel's Ascii Export"  

	(

				if(selection.count==0) then
				(
				messagebox ("NO OBJECTS SELECTED , NOTHING TO EXPORT !")
				)

else if (sve = getsavefilename caption:"Save to:" types:"Miguel's Ascii (*.ascii)|*.ascii") != undefined do

			(

			
			vertices_count=0

			outfile = getfilenamefile sve

			outpath = getfilenamepath sve

			outfile += ".ascii"

			out = createfile (outpath + "\\" + outfile)
			
						
			center=geometry[1].center
--			max=geometry[1].max
--			min=geometry[1].min
--			box=max-min
		
			for i = 1 to selection.count do
			(
				format "START\n" to:out
				format "%\n" selection[i].name  to:out
				
				if(selection[i].material != undefined) then
				format "%\n" (selection[i].material.diffuseMap.filename) to:out
			
				else
				format "color:\n%\n%\n%\n" (selection[i].wirecolor.r) (selection[i].wirecolor.g) (selection[i].wirecolor.b) to:out
				
				
				for j=1 to selection[i].numVerts do
				(
					vertices=getvert selection[i] j
--					messagebox (" "+(getvertcolor selection[i] 1).r as string + "")


--					 uncomment if you don't want autocentering 
					 center.x=center.y=center.z=0
					
					format "%\n%\n%\n" (vertices.x-center.x) (vertices.y-center.y) (vertices.z-center.z) to:out

				)
				
			
				format "NEXT\n" to:out
				
				for j=1 to selection[i].numverts do
				(
					vertices=getNormal selection[i] j
					format "%\n%\n%\n" vertices.x vertices.y vertices.z to:out
				)
				
				format "NEXT\n" to:out
				
					for j=1 to selection[i].numtVerts do
				(
					vertices=gettvert selection[i] j
					format "%\n%\n" (vertices.x) (vertices.y) to:out
geometry
				)
				
				format "NEXT\n" to:out
				
					for j=1 to selection[i].numfaces do
				(
					vertices=gettvface selection[i] j
					format "%\n%\n%\n" ((vertices.x-1) as integer) ((vertices.y-1) as integer) ((vertices.z-1) as integer) to:out
				)

				format "NEXT\n" to:out
				for j=1 to selection[i].numFaces do
				(
					faces=getface selection[i] j
					format "%\n%\n%\n" ((faces.x-1) as integer) ((faces.y-1) as integer) ((faces.z-1) as integer) to:out
					-- addition
					facenorm=getFaceNormal selection[i] j
					format "%\n%\n%\n" ((facenorm.x) ) ((facenorm.y) ) ((facenorm.z) ) to:out

					
				)
			format "END\n" to:out
			)
			
		
			format "VERY END\n" to:out

			close out

			messagebox ("EXPORTED!\nOBJECTS:"+ selection.count as string + "\n\nREADY!")

			)

	)
